
1 REM 'THE LAST ARENA' by Dave Hassler, March 2023,
2 REM for KIM-1 BASIC 9 as used on the PAL-1 6502 computer.
3 REM Based on the cards-and-dice counting game 'Dice of Destiny'
4 REM by Dr. Michael Hartley.

7 DIM C(52), PC(26), CC(26), PD(4), CD(4), T(7)

10 PT=0:CT=0:PP=23:CP=23
12 E$=CHR$(27)+CHR$(91):CL$=E$+"2J":HM$=E$+"H":RV$=E$+"7m":NO$=E$+"m"
13 ST$=HM$+E$+"7B":ST$=ST$+E$+"15C":POKE10920,169

15 DL$=ST$+"                                             "

20 GOTO 1797: REM SPLASH SCREEN, INSTR TO FOLLOW

80 PRINT:PRINT"PREPARING THE TROOPS..."

90 GOSUB 1000

99 REM DEAL 3 CARDS FACE UP TO EACH

100 PRINT CL$
105 LM=0
110 IFCP<-1THEN 1700: REM   END GAME

115 IFCP=-1THENCP=0:PP=0

120 PRINT"SMADA FORCES":PRINT"LEFT:";CP:PRINTE$+"2A";E$+"15C";
122 IFCP=0THENCP=-1
125 X=CC(CP+3):Y=CC(CP+2):Z=CC(CP+1)
130 GOSUB 1200: REM PRINT 3 COMPUTER CARDS
132 T(5)=CC(CP+3):T(6)=CC(CP+2):T(7)=CC(CP+1)
135 PRINT:PRINT:PRINT
140 PRINT"LEOND FORCES":PRINT"LEFT:";PP:PRINTE$+"2A";E$+"15C";
142 IFPP=0THENPP=-1
145 X=PC(PP+3):Y=PC(PP+2):Z=PC(PP+1)
150 GOSUB 1200: REM PRINT 3 PLAYER CARDS
155 T(1)=PC(PP+3):T(2)=PC(PP+2):T(3)=PC(PP+1)
157 BC=3:BP=3:IFCP=-1THENBC=2:BP=2

160 GOTO 700: REM TEST FOR ALL 3 PWR CARDS IN SQUAD FIRST
170 GOSUB 1300: REM TEST FOR QUEENS, GIVE EXTRA DICE
179 REM *** BATTLE!!!
180 GOSUB 1400: REM DET. HIGHEST REMAINING # CARD, MARK IT
189 REM ** ROLL DICE
190 PRINTDL$:PRINTST$;"PRESS <RETURN> TO ROLL...";
195 INPUT A$
197 PRINTDL$
200 GOSUB 1100
205 REM *** TIME TO FIGHT, THEN CHECK FOR ACE AND KING
210 GOTO 1550

300 FORL=1TO3000:NEXT:RETURN

699 REM GOT 3 PWRS? -- AUTO LOSE (OR LIMBO IF BOTH ALL 3)
700 F1=0:FORI=1TO3:IFT(I)>10THENF1=F1+1
705 NEXT
710 F2=0:FORI=5TO7:IFT(I)>10THENF2=F2+1
715 NEXT
720 IFF1=3ANDF2=3THENLM=6:PP=PP-3:CP=CP-3:PRINTDL$
725 IFF1=3ANDF2=3THENPRINTST$;"*BOTH* HAVE 3 FACE CARDS: ALL LOSE!"
727 IFF1=3ANDF2=3THEN100
730 IFF1=3THENPP=PP-3:CP=CP-3:CT=CT+6:BW=5:PRINTDL$
735 IFF1=3THENPRINTST$;"THREE FACE CARDS - SMADA WINS!": GOTO100
740 IFF2=3THENCP=CP-3:PP=PP-3:PT=PT+6:BW=1:PRINTDL$
745 IFF2=3THENPRINTST$;"THREE FACE CARDS - LEOND WINS!": GOTO100
750 GOTO 170


944 REM *** REPRINT THE CARDS

945 PRINTHM$:PRINTE$+"15C";
950 X=T(5):Y=T(6):Z=T(7)
955 GOSUB 1200: REM PRINT 3 COMPUTER CARDS
960 X=T(1):Y=T(2):Z=T(3)
962 PRINT:PRINT:PRINT:PRINTE$+"15C";
965 GOSUB 1200: REM PRINT 3 PLAYER CARDS
970 RETURN

999 REM SHUFFLE AND DEAL CARDS
1000 FOR I=1TO52
1010 R=INT(RND(1)*52+1)
1020 IF C(R)<>0THEN1010
1025 W=INT(((I/13-(INT(I/13)))*13)+.5)
1027 IFW=0THENW=13
1030 C(R)=W:NEXT
1040 FOR I=1TO26
1050 PC(I)=C(I):CC(I)=C(I+26)
1060 NEXT:PC(0)=14:CC(0)=14:RETURN

1099 REM ROLL DICE AND PRINT - COMPUTER 1ST
1100 DC=0:FORK=1TOCD:CD(K)=INT(RND(1)*6)+1:DC=DC+CD(K):NEXT
1105 DP=0:FORK=1TOPD:PD(K)=INT(RND(1)*6)+1:DP=DP+PD(K):NEXT
1110 PRINTHM$:PRINTE$+"4B";"ROLL: ";
1112 FORK=1TOCD
1115 CD$=STR$(CD(K)):T$=MID$(CD$,2,1):PRINTRV$;T$;NO$;
1117 PRINT" ";:NEXT:PRINT
1120 PRINTHM$:PRINTE$+"12B";"ROLL: ";
1122 FORK=1TOPD
1125 PD$=STR$(PD(K)):T$=MID$(PD$,2,1):PRINTRV$;T$;NO$;
1127 PRINT" ";:NEXT:PRINT
1129 IFRR=1THEN1550
1130 RETURN

1200 REM PRINT CARDS
1202 T1$=STR$(X):T2$=STR$(Y):T3$=STR$(Z)
1205 IFX>9ORX=1THEN T4=X:GOSUB1240:T1$=FC$:GOTO1207
1206 T1$=RIGHT$(T1$,1)
1207 IFY>9ORY=1THEN T4=Y:GOSUB1240:T2$=FC$:GOTO1210
1208 T2$=RIGHT$(T2$,1)
1210 IFZ>9ORZ=1THEN T4=Z:GOSUB1240:T3$=FC$:GOTO1214
1212 T3$=RIGHT$(T3$,1)
1214 PRINT"+---+   +---+   +---+"
1215 PRINTE$+"15C";"|";T1$;"  |   |";T2$;"  |   |";T3$;"  |"
1217 PRINTE$+"15C";"|   |   |   |   |   |"
1218 PRINTE$+"15C";"|  ";T1$;"|   |  ";T2$;"|   |  ";T3$;"|"
1220 PRINTE$+"15C";"+---+   +---+   +---+"
1230 RETURN

1240 IFT4=13THENFC$="K"
1250 IFT4=12THENFC$="Q"
1260 IFT4=11THENFC$="J"
1270 IFT4=10THENFC$="T"
1275 IFT4=1 THENFC$="A"
1280 IFT4=14THENFC$=" "
1290 RETURN

1299 REM QUEEN TEST
1300 PD=2:FQ=0:FL=0:FORK=1TO3:IFT(K)<>12THEN1320
1305 PRINTDL$:PRINTST$;"LEOND: A DUCHESS FOR AN EXTRA DIE (Y/N)";
1310 INPUTA$:IFLEFT$(A$,1)<>"Y"THEN1325
1315 FQ=FQ+1:T(K)=14:FL=1:BP=BP-1
1320 NEXT:PD=PD+FQ: REM PLAYER DICE
1325 CD=2:FQ=0:FORK=5TO7:IFT(K)<>12THEN1330
1326 FQ=FQ+1:T(K)=14:FL=1:BC=BC-1
1327 PRINTDL$
1328 PRINTST$;"SMADA GAVE A DUCHESS FOR AN EXTRA DIE."
1330 NEXT:CD=CD+FQ: REM COMPUTER DICE
1333 IF FL=1THENFL=0:GOSUB 945: REM REPRINT CARDS
1335 RETURN


1349 REM ** BUBBLE SORT THREE CARDS
1350 IFX>YTHENW=X:X=Y:Y=W
1360 IFY>ZTHENW=Y:Y=Z:Z=W
1370 IFX>YTHENW=X:X=Y:Y=W
1380 RETURN

1399 REM ** MARK HIGHEST REMAINING CARD IN EACH SQUAD, COMPUTER 1ST
1400 FB=0:X=T(5):Y=T(6):Z=T(7)
1405 GOSUB 1350
1410 IFZ<12THENFORI=5TO7:IFT(I)=ZTHENFB=1:GOTO 1440
1415 IFZ<12THENNEXT
1420 IFY<12THENFORI=5TO7:IFT(I)=YTHENFB=1:GOTO 1440
1425 IFY<12THENNEXT
1430 IFX<12THENFORI=5TO7:IFT(I)=XTHENFB=1:GOTO 1440
1435 IFX<12THENNEXT
1437 IFFB=0THEN 1520
1439 REM *** CARD TO PLAY IS IN T(I)
1440 PRINTHM$:PRINTE$+"5B";SPC(20);"                    "
1450 W=(I-5)*8
1453 PRINTHM$:PRINTE$+"5B";SPC(20+W);"'"
1460 FB=0:X=T(1):Y=T(2):Z=T(3)
1465 GOSUB 1350
1470 IFZ<12THENFORJ=1TO3:IFT(J)=ZTHENFB=1:GOTO 1500
1475 IFZ<12THENNEXT
1480 IFY<12THENFORJ=1TO3:IFT(J)=YTHENFB=1:GOTO 1500
1485 IFY<12THENNEXT
1490 IFX<12THENFORJ=1TO3:IFT(J)=XTHENFB=1:GOTO 1500
1495 IFX<12THENNEXT
1497 IFFB=0THEN 1520
1499 REM *** CARD TO PLAY IS IN T(J)
1500 PRINTHM$:PRINTE$+"7B";SPC(20);"                    "
1510 W=(J-1)*8
1515 PRINTHM$:PRINTE$+"7B";SPC(20+W);","
1517 IFRR=1THEN1100
1520 RETURN

1549 *** REM    FIGHT!!!    ***

1550 FL=0:T=0:U=0:RR=0:T=DC+T(I):U=DP+T(J)

1555 IFT=UTHEN PRINTDL$
1560 IFT=UTHEN PRINTST$;T;"- A DRAW!  FIGHT ON!":GOSUB300:GOTO 190
1565 PRINT DL$


1570 IFU<TTHENPRINTST$;"SMADA'S";T;"BEATS LEOND'S";U
1575 IFU<TTHENV=T(J):T(J)=14:FL=2
1580 IFT<UTHENPRINTST$;"LEOND'S";U;"DEFEATS SMADA'S";T
1585 IFT<UTHENV=T(I):T(I)=14:FL=1
1586 GOSUB300:GOSUB945
1587 IFFL=2THEN 1620: REM CHECK FOR P ACE OR KING
1590 IFFL=1THEN 1660:REM C GOT ACE OR KING?

1595 IFFL=1THENBC=BC-1
1597 IFFL=2THENBP=BP-1

1598 IFBC>0ANDBP>0THEN180: REM GO AGN

1600 IFBP=0ANDBC>0THENPRINTDL$
1602 IFBP=0ANDBC>0THENPRINTST$;"SMADA WINS THIS ROUND!":GOSUB300
1603 IFBC=0ANDBP>0THENPRINTDL$
1605 IFBC=0ANDBP>0THENPRINTST$;"LEOND IS VICTORIOUS!":GOSUB300

1610 IFBC>0THENCP=CP-3:PP=PP-3:CT=CT+6+LM:GOTO100
1615 IFBP>0THENCP=CP-3:PP=PP-3:PT=PT+6+LM:GOTO100

1619 REM *** P HAVE K/A?
1620 FORK=1TO3:IFT(K)<>13THEN1635
1622 PRINTDL$
1625 PRINTST$;"LEOND: TRADE A DUKE FOR A RE-MATCH (Y/N)";
1627 INPUTA$:IFLEFT$(A$,1)<>"Y"THEN1640
1630 T(K)=14:T(J)=V:RR=1:BP=BP-1:GOSUB945:GOTO1400
1635 NEXT

1640 FORK=1TO3:IFT(K)<>1THEN1655
1642 PRINTDL$
1645 IFT(K)=1THENPRINTST$;"LEOND: SEND A SPY FOR LAST FIGHTER (Y/N)";
1647 INPUTA$:IFLEFT$(A$,1)<>"Y"THEN1655
1650 IFT(K)=1THENT(K)=14:T(J)=V:RR=1:BP=BP-1:GOSUB945:GOTO1400
1655 NEXT:IFRR=0THEN1595
1657 GOTO 1598

1659 REM *** KING/ACE CHECK FOR C
1660 FORK=5TO7:IFT(K)=13THENPRINTDL$
1665 IFT(K)=13THENPRINTST$;"A SMADA DUKE SURRENDERS FOR A RE-MATCH."
1670 IFT(K)=13THENT(I)=V:RR=1:BC=BC-1
1672 IFT(K)=13THENT(K)=14:GOSUB300:GOSUB945:GOTO1400
1675 NEXT

1680 FORK=5TO7:IFT(K)=1THENPRINTDL$
1685 IFT(K)=1THENPRINTST$;"A SMADA SPY RETURNS THE BEATEN WARRIOR."
1690 IFT(K)=1THENT(I)=V:RR=1:BC=BC-1
1692 IFT(K)=1THENT(K)=14:GOSUB300:GOSUB945:GOTO1400
1695 NEXT:IFRR=0THEN1595
1697 GOTO1598

1699 REM ***   E N D   O F   G A M E   ***
1700 PRINT"THE CONTEST IS OVER! ";
1702 L$="Smada":W$="Leond"
1705 IFCT>PTTHENPRINTRV$;" S M A D A ";NO$;
1710 IFCT>PTTHENW$="Smada":L$="Leond":GOTO1720
1715 PRINTRV$;" L E O N D ";NO$;
1720 PRINT" shall rule over all!"
1725 PRINT:PRINT"The final tally (rounds):"
1730 PRINTE$+"4m";"SMADA";NO$;"       ";E$+"4m";"LEOND";NO$
1735 PRINT" ";CT/6;"         ";PT/6
1740 PRINT:PRINT"The head of the Council of ";W$;" proclaimed,"
1745 PRINT"'May all of our new citizens enjoy their new rights and"
1750 PRINT"privileges, and carry out their new responsibilities."
1755 PRINT"From now on, this day shall be remembered as Unity Day!'"
1760 PRINT:PRINT"A mighty cheer arose from the ";W$;" faction, while"
1765 PRINT"those on the ";L$;" side appeared a little less"
1770 PRINT"enthusiastic. 'Oh well,' one now ex-duke of ";L$;" was"
1775 PRINT"heard to say, 'being a tax collector beats execution...'"
1780 PRINT:INPUT"PLAY AGAIN (Y/N)";A$
1785 IFLEFT$(A$,1)="Y"THEN CLEAR:GOTO 10
1790 END

1797 PRINTCL$:PRINTE$+"1m"
1798 REM ASCII art from www.asciiart.eu
1799 REM title banner generated at textkool.com

1800 PRINT" |''||''| '||                ||"
1801 PRINT"    ||     ||                ||                     ||"
1802 PRINT"    ||     ||''|, .|''|,     ||      '''|.  ('''' ''||''"
1803 PRINT"    ||     ||  || ||..||     ||     .|''||   `'')   ||"
1804 PRINT"   .||.   .||  || `|...     .||...| `|..||. `...'   `|..'"
1805 PRINT
1807 PRINT"       /.\"
1808 PRINT"      // \\"
1809 PRINT"     //...\\    '||''| .|''|, `||''|,   '''|."
1810 PRINT"    //     \\    ||    ||..||  ||  ||  .|''||"
1811 PRINT"  .//       \\. .||.   `|...  .||  ||. `|..||.";NO$
1900 PRINT
1902 PRINT"                                       (\"
1904 PRINT"   .------------------------------------\\,,,,,,,,,,()"
1906 PRINT"  (<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*)\\\\\\\\\(*)"
1908 PRINT"   ^------------------------------------//''''''''''()"
1910 PRINT"                                       (/"
1920 PRINTE$+"1m";"                 by Dave Hassler";NO$:PRINT
1930 PRINT"1) Play now  2) Instructions  3) The Story  4) Quit"
1940 PRINT:INPUT"Your choice";A$
1950 A=VAL(LEFT$(A$,1)):IFA<1ORA>4THENPRINTCL$:GOTO1930
1951 PRINTCL$:ON A GOTO 80,1952,1966,1790
1952 PRINT"  Basically, be patient and follow the prompts.":PRINT
1953 PRINT"  There are nine rounds of combat of three fighters each."
1954 PRINT"The 'tick' marks will show which troopers are in play."
1955 PRINT"The winner of an individual melee will have the higher"
1956 PRINT"total of the fighter's value plus a dice roll. The squad"
1957 PRINT"with a warrior left standing will win the round."
1958 PRINT"  A 'duke' (K) can hostage himself for a re-roll, while a"
1959 PRINT"'duchess' (Q) can hostage herself for an extra die. A spy"
1960 PRINT"(A) can sneak the last warrior beaten out of detention,"
1961 PRINT"or serve as a very poor fighter with a value of 1."
1962 PRINT"Captains (J) are the most capable soldiers, but if three"
1963 PRINT"'face cards' come up in a row, the round is lost."
1964 PRINT"  You will play as the Grand Duke of Leond.":PRINT
1965 INPUT"Press <RETURN> to continue. ";A$:PRINTCL$:GOTO1930

1966 PRINT"  No one alive remembered when it all began."
1967 PRINT"It may have been over principles, or over borders..."
1968 PRINT"it was more likely over a cow. At any rate, Smada and"
1969 PRINT"Leond had been at each others' throats for generations."
1970 PRINT"Finally, they'd had enough. Envoys were sent, diplomacy"
1971 PRINT"tried. The first thought was a merger"
1972 PRINT"of the two city-states, but a wise old  ,-==-,"
1973 PRINT"scholar, advising the talks, reminded   \/\/\/"
1974 PRINT"the delegates: 'Do I need tell of the    \\//"
1975 PRINT"ancient land of lore: Czechoslovakia?   .-''-."
1976 PRINT"That did not endure, nor was anyone   .'.-''-.'.---."
1977 PRINT"truly content with the marriage.'    / /    .'\ \--.'."
1978 PRINT"  And so, with some disappointed     | |   / /| |   \ \"
1979 PRINT"muttering of agreement, that idea    \ \  | | / /    | |"
1980 PRINT"was scrapped.                         '.'-:\ \.'    / /"
1981 PRINT"                                        '---; '-..-'.'"
1982 PRINT"Press <RETURN> to continue...                `'----'"
1983 INPUTA$

1984 PRINTCL$
1985 PRINT"          (    Next, a competition of skill was sought,"
1986 PRINT"           )     with the two lands vying for the right"
1987 PRINT"      .-..---..-.     to govern. 'The Great Leond-Smada"
1988 PRINT"  ,-='  /  |  \  `=-.    Bake Off' was nixed when the"
1989 PRINT" :--..-----------..--;   Smadans protested the name,"
1990 PRINT"  \................./   arguing that alphabetical order"
1991 PRINT"                       was no sane way to determine the"
1992 PRINT"name of anything, especially as 'everyone' knew that"
1993 PRINT"Smada possessed superior culinary talent: 'It simply"
1994 PRINT"wouldn't be fair to you,' Duchess Modnar of Smada opined,"
1995 PRINT"with a smirk."
1996 PRINT"  Similar proposals such as a poetry slam, a seashell"
1997 PRINT"sculpture event, and a 24-hour 'code-in' were also"
1998 PRINT"rejected, usually on the basis that they were all"
1999 PRINT"judged, rather than objective, events."
2000 PRINT:INPUT"  Press <RETURN> to continue...";A$

2001 PRINTCL$:PRINT"  It was Grand Duke Drof of Leond who (in spite"
2002 PRINT"of having an exceedingly fine group of shell sculptors)"
2003 PRINT"finally said, 'OK, let's duke it out"
2004 PRINT"...so to speak. Your best warriors         /!\"
2005 PRINT"versus our best -- 'zherbt pt zherbt'     / ! \"
2006 PRINT"('one-to-one' in Smado-Leondian),  /\     )---("
2007 PRINT"but just to the point of throwing (  `.----(-)---------"
2008 PRINT"in the glurr... we're done with   |            ...--''"
2009 PRINT"all this killing business now.'   (      ,-.-|-"
2010 PRINT"  It seemed sensible enough, but   \    ,' | |"
2011 PRINT"then Grand Duchess Krid of Smada    \  /   | |"
2012 PRINT"rose, quieting the assembly.         \(    | |"
2013 PRINT"  'I agree, mainly, but I demand one  `    | |"
2014 PRINT"thing more... Regardless of how this ends, | |"
2015 PRINT"all nobles will retain their property"
2016 PRINT"and be free from exile, or ... worse. We will give up"
2017 PRINT"our titles to secure our lands and safety. Agreed?'"
2018 PRINT"A moment of stunned silence followed, but then the hall"
2019 PRINT"erupted with a loud chorus of assent. 'That Krid,'"
2020 PRINT"whispered Duke Nivram to Drof as the applause and"
2021 PRINT"handclasps continued, 'She's a whole lot more hrrsey than"
2022 PRINT"than I ever thought...indeed!' ...which made Drof blush."
2023 INPUT"  Press <RETURN> to continue...";A$
2024 PRINTCL$:GOTO1930
